/*  Time-stamp: <2006-03-25 15:07:45 noike>  */
#include  "4ru.h"


int _4R_file_out(char *org_filename, int ext_type, NOTE_NODE *note_top, NOTE_HEADER *note_header_info,
		 int smf_divi, WRITE_CTRL  wctrl, xmlDoc *xml_doc_top, DRUM_DEF *drum_data)
{
  char filename4R[STR_LEN];
  NOTE_NODE *note_re_4R[PART_NUM];  /*  note_top $B$r!$(Bre_4R() $B$KEO$9$?$a$NCg2pJQ?tG[Ns(B  */
  char buf[STR_LEN];


  /*  MusicXML(4R) $B%U%!%$%k$N%U%!%$%kL>@8@.(B  */
  sprintf(filename4R, "4R_%s", org_filename);
  if(ext_type != EXT_XML){
    strcat(filename4R, ".xml");
  }

  if(xml_doc_top == NULL){  /*  note $B7A<0%G!<%?$+$i(B XML DOM $BLZ$r@8@.$9$k(B  */
    xml_doc_top = note2xml(note_top, note_header_info, drum_data);
  }else{  /* XML $B%G!<%?$KBP$7$F(B 4R attribute $B$rIU2C$9$k!%(B*/
    ;
  }

  /*  for debug. $B"-$"$H$G>C$9(B  */
#if 1
  /*  MusicXML(4R) $B=q$-=P$7(B  */
  if(xmlSaveFormatFileEnc(filename4R, xml_doc_top, NULL, 1) == -1){
    br_printf(2, "MusicXML(4R): %s Write failed.\n\n", filename4R);
  }else{
    br_printf(4, "%s", filename4R);
    br_printf(-1,"(MusicXML(4R)) is written. ");
    br_printf(4, "Success.\n\n");
  }
#endif
  /*  for debug. $B",$"$H$G>C$9(B  */

  koko(2);
  exit(0);


  /*  <note> $B$NB0@-(B(attack, release, dynamics, end-dynamics)$B$rDI2C!$=$@5$9$k(B  */
  note_re_4R[0] = note_top;
  re_4R(note_re_4R, 1, smf_divi);  /*  $BBh0l0z?t$,$A$g$C$H$@$1%H%j%C%-!<(B  */
  
  /*  $B4{B8%U%!%$%k$X$N>e=q$-%A%'%C%/(B  */
  if(wctrl.ow_chk == ON){
    if(exist_chk(filename4R) == EXIST){
      br_printf(4, "%s", filename4R);
      br_printf(-1, "  ");
      br_printf(3, "overwrite ok? (y/n)\n");
      fgets(buf, STR_LEN, stdin);
      if(tolower(buf[0]) != 'y'){
	br_printf(6, "not written %s.\n", filename4R);
	return EXIT_FAILURE;
      }
    }
  }
  
  /*  MusicXML(4R) $B=q$-=P$7(B  */
  if(xmlSaveFile(filename4R, xml_doc_top) == -1){
    br_printf(2, "MusicXML(4R): %s Write failed.\n\n", filename4R);
  }else{
    br_printf(4, "%s", filename4R);
    br_printf(-1,"(MusicXML(4R)) is written. ");
    br_printf(4, "Success.\n\n");
  }

  return  EXIT_SUCCESS;
}
