/*  Time-stamp: <2004-04-30 20:24:23 >  */
#include  "NOTEfile.h"


int beat2q_time(NOTE_NODE *top, NOTE_HEADER *header_info)
{
  NOTE_NODE *cur;
  NOTE_NODE *same;
  double mul;

  if(header_info->beat_bunbo != -1){
    mul = 4.0 / header_info->beat_bunbo;
  }else{
    mul = 1.0;
  }


  cur = top;
  while(1){
    if(cur == NULL){   break; }
    same = cur;
    while(1){
      if(same == NULL){  break; }

      same->on_time.q_time = same->on_time.beat * mul;

      if( (same->ident == NOTE) || (same->ident == REST) ){
	same->on_diff.q_time = same->on_diff.beat * mul;
	same->len.q_time     = same->len.beat * mul;
	same->len_diff.q_time= same->len_diff.beat * mul;
      }

#if 0
      br_printf(-1, "%lf %lf %lf %07d %lf\n",
		same->on_time.beat,
		same->on_time.real,
		same->on_time.meas,
		same->on_time.delta,
		same->on_time.q_time
		);
#endif
#if 0
      br_printf(-1, "%lf %lf %lf %07d %lf\n",
		same->on_diff.beat,
		same->on_diff.real,
		same->on_diff.meas,
		same->on_diff.delta,
		same->on_diff.q_time
		);
#endif
#if 0
      br_printf(-1, "%lf %lf %lf %07d %lf\n",
		same->len.beat,
		same->len.real,
		same->len.meas,
		same->len.delta,
		same->len.q_time
		);
#endif
#if 0
      br_printf(-1, "%lf %lf %lf %07d %lf\n",
		same->len_diff.beat,
		same->len_diff.real,
		same->len_diff.meas,
		same->len_diff.delta,
		same->len_diff.q_time
		);
#endif

      same = same->samenext;
    }
    
    cur = cur->next;
  }

  return EXIT_SUCCESS;
}


