/*  Time-stamp: <2004-10-25 16:41:53 >  */
#include  "4ru.h"
#include  "GLcolors.h"


extern int gpr_v_line;
extern int win_h;
extern int win_w;


void draw_group_line(NOTE_NODE *s_node, NOTE_NODE *e_node, int Ltop, int level)
{
  char str_tmp[STR_LEN];
  GLdouble colors[4];
  double xs;
  double xe;

  int i;

/*   NOTE_NODE *cur; */
/*   NOTE_NODE *same; */
/*   int loop; */


  if( (s_node == NULL) || (e_node == NULL) ){
    return;
  }


#if 0
  printf("------ start ------\n");
  cur = s_node;
  loop = 1;
  while(loop){
    if(cur == NULL){  break; }
    same = cur;
    while(same != NULL){
      print_node(same);
      if(same == e_node){
	loop = 0;
	break;
      }
      same = same->samenext;
    }
    cur = cur->next;
  }
  printf("------ stop ------\n\n1");
#endif

  if(s_node->draw_xs < 0){
    xs = 0;
  }else{
    xs = s_node->draw_xs;
    draw_H_line(xs, Ltop + GROUP_LINE_BIAS + (level * GROUP_LINE_INTER) - GROUP_LINE_LR_H,
		xs + GROUP_LINE_LR_W, Ltop + GROUP_LINE_BIAS + (level * GROUP_LINE_INTER),
		OpenGLcolors[1], 2);
  }

  if(e_node->draw_xe < 0){
    xe = win_w;
  }else{
    xe = e_node->draw_xe;
    draw_H_line(e_node->draw_xe - GROUP_LINE_LR_W, Ltop + GROUP_LINE_BIAS + (level * GROUP_LINE_INTER),
		e_node->draw_xe, Ltop + GROUP_LINE_BIAS + (level * GROUP_LINE_INTER) - GROUP_LINE_LR_H,
		OpenGLcolors[1], 2);
  }

  if( eq(xs, 0) || eq(xe, 0) ){
    return;
  }

  draw_H_line(xs + GROUP_LINE_LR_W, Ltop + GROUP_LINE_BIAS + (level * GROUP_LINE_INTER),
	      xe - GROUP_LINE_LR_W, Ltop + GROUP_LINE_BIAS + (level * GROUP_LINE_INTER),
	      OpenGLcolors[1], 2);

  sprintf(str_tmp, "%d ", level);
/*   put_str(((e_node->draw_xe + s_node->draw_xs) / 2.0), */
/*     Ltop - GROUP_LINE_BIAS + (level * GROUP_LINE_INTER), */
/*     0, OpenGLcolors[1], str_tmp); */
  put_str(s_node->draw_xs + GROUP_LINE_LR_W,
	  Ltop + GROUP_LINE_BIAS + (level * GROUP_LINE_INTER) + 2,
	  0, OpenGLcolors[1], str_tmp);

  for(i = 0; i < 4; i++){
    colors[i] = OpenGLcolors[5][i];
  }
  colors[3] *= 0.7;
  draw_V_line(s_node->draw_xs, Ltop - GROUP_LINE_BIAS + (level * GROUP_LINE_INTER) + GROUP_LINE_LR_H,
	      s_node->draw_xs, s_node->draw_ys,
	      colors, 1);
  draw_V_line(e_node->draw_xe, Ltop - GROUP_LINE_BIAS + (level * GROUP_LINE_INTER) + GROUP_LINE_LR_H,
	      e_node->draw_xe, e_node->draw_ye,
	      colors, 1);
}


