/*  Time-stamp: <2004-07-01 22:04:34 >  */
#include  "4Ru.h"
#include  <glut.h>

#include  "GLcolors.h"

extern int win_id;
extern int help_win;
extern int win_w;
extern int win_h;


static int help_win_id;
static int help_win_w;
static int help_win_h;



void open_key_help_win(void)
{
  help_win_w = 480;
  help_win_h = 240;

/*   help_win_id = glutCreateSubWindow(win_id, (win_w - help_win_w), 0, help_win_w, 200); */

  glutInitDisplayMode(GLUT_RGB);
  glutInitWindowSize(help_win_w, help_win_h);
  glutInitWindowPosition(0, 0);
  help_win_id = glutCreateWindow("4Ru help");

  glViewport(0, 0, help_win_w, help_win_h);

  glEnable(GL_LINE_STIPPLE);
  glEnable(GL_LINE_SMOOTH);
  glEnableClientState(GL_COLOR_ARRAY);
  glEnableClientState(GL_VERTEX_ARRAY);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glRenderMode(GL_RENDER);

  glutDisplayFunc(help_win_flush);
  glutKeyboardFunc(key_switcher);
  glutSpecialFunc(Skey_switcher);
  glFlush();

  glutSetWindow(win_id);

  help_win = ON;
}


void close_key_help_win(void)
{
  glutDestroyWindow(help_win_id);

  help_win = OFF;

  return;
}


void help_win_flush(void)
{
  int str_y;
  int str_y_inter;


  glutSetWindow(help_win_id);

  glViewport(0, 0, win_w, win_h);

  glClearColor(1.0, 1.0, 1.0, 1.0);   /*  Background color  */
  glColor4d(0.0, 0.0, 0.0, 1.0);           /*  Foreground color  */
  glClear(GL_COLOR_BUFFER_BIT);

  str_y = 10;
  str_y_inter = 14;

  draw_H_line(0, win_h - 100, win_w, win_h - 100, OpenGLcolors[1], 2);


  put_str(0, win_h - 100, 0, OpenGLcolors[0], "[Q] Quit (Exit)");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], "[S] Regularized note / Real Performance (Toggle)");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], "[D] Deviation Display  On / Off  (Toggle)");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], "[V] Velocity Value Display  On / Off  (Toggle)");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], "[M] Output SMF");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], "[P] Play");
  str_y += str_y_inter;


  put_str(0, str_y, 0, OpenGLcolors[1], "        [<-] Scroll right 1 note(1 chord)");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], "        [->] Scroll left  1 note(1 chord)");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], " [Ctrl]+[<-] Scroll right 1 measure");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], " [Ctrl]+[->] Scroll left  1 measure");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], "[Shift]+[<-] Jump to top of tune");
  str_y += str_y_inter;

  put_str(0, str_y, 0, OpenGLcolors[1], "[Shift]+[->] Jump to last of tune");
  str_y += str_y_inter;


  put_str(0, str_y, 0, OpenGLcolors[1], "[F1]Display this help");
  str_y += str_y_inter;

  glFlush();

  glutSetWindow(win_id);

  return;
}
