#include  "NOTEfile.h"
#include  "disp_errline.h"


int note_arranger_parse(FILE *fp, char *filename,
			int line, char linebuf[], int *idx, char token[],
			NOTE_HEADER *header_info, NOTE_NODE *cur)
{
  char err_mesg[READBUF_LEN];

  fp = fp;
  filename = filename;
  line = line;


  get_token(linebuf, idx, token);  /*  ʸɤФ  */
  if(strcmp(token, " ") != 0){
    sprintf(err_mesg, jcode_local("ζ˺졩\n"), token);
    disp_errline(filename, line, linebuf, *idx, err_mesg);
    fclose(fp);
    exit(EXIT_FAILURE);
  }
  get_token(linebuf, idx, token);

  if(header_info != NULL){
    strcpy(header_info->arranger, jcode_local(token));
  }
  if(cur != NULL){
    strcpy(cur->str[0], jcode_local(token));
    cur->ident = ARRANGER;
  }

  get_token(linebuf, idx, token);

  /*
  printf("\narranger: %s\n", header_info->arranger);
  */


  return EXIT_SUCCESS;
}
