/*  Time-stamp: <2005-05-06 05:49:49 >  */
#include  "4ru.h"


int real2beat(NOTE_NODE *top, NOTE_HEADER *header_info)
{
  NOTE_NODE *cur;
  NOTE_NODE *same;
  double qbeattime;


  qbeattime = calc_qbeattime(header_info->beattime, header_info->beattime_base,
			     header_info->bpm, header_info->bpm_base);
/*   printf("qbeattime: %f\n", qbeattime); */

  cur = top;
  while(1){
    if(cur == NULL){   break; }
    same = cur;
    while(1){
      if(same == NULL){  break; }

      if(same->ident == BEATTIME){
	qbeattime = calc_qbeattime(same->val[0], same->val[1], -1, -1);
      }else if(same->ident == BPM){
	qbeattime = calc_qbeattime(-1, -1, same->val[0], same->val[1]);
      }

      same->on_time.beat = same->on_time.real / qbeattime;
      same->on_time.q_time = same->on_time.beat;
      same->on_time.meas = same->on_time.beat;


      if( (same->ident == NOTE) || (same->ident == REST) ){
	same->on_diff.beat = same->on_diff.real / qbeattime;
	same->len.beat = same->len.real / qbeattime;
	same->len_diff.beat = same->len_diff.real / qbeattime;

	same->on_diff.q_time = same->on_diff.beat;
	same->len.q_time = same->len.beat;
	same->len_diff.q_time = same->len_diff.beat;

	same->on_diff.meas = same->on_diff.beat;
	same->len.meas = same->len.beat;
	same->len_diff.meas = same->len_diff.beat;

      }

#if 0
      br_printf(-1, "%lf %lf %lf %07d %lf\n",
		same->on_time.beat,
		same->on_time.real,
		same->on_time.meas,
		same->on_time.delta,
		same->on_time.q_time
		);
#endif
#if 0
      br_printf(-1, "%lf %lf %lf %07d %lf\n",
		same->on_diff.beat,
		same->on_diff.real,
		same->on_diff.meas,
		same->on_diff.delta,
		same->on_diff.q_time
		);
#endif
#if 0
      br_printf(-1, "%lf %lf %lf %07d %lf\n",
		same->len.beat,
		same->len.real,
		same->len.meas,
		same->len.delta,
		same->len.q_time
		);
#endif
#if 0
      br_printf(-1, "%lf %lf %lf %07d %lf\n",
		same->len_diff.beat,
		same->len_diff.real,
		same->len_diff.meas,
		same->len_diff.delta,
		same->len_diff.q_time
		);
#endif

      same = same->samenext;
    }
    
    cur = cur->next;
  }

  return EXIT_SUCCESS;
}


