/*  Time-stamp: <2005-05-21 17:36:03 >  */
#ifdef XML
#include  "xml2note.h"
#else
#include  "NOTEfile.h"
#include  "disp_ctr.h"
#endif

#include  "exist_chk.h"
#include  "enter_fname.h"
#include  "strrev.h"
#include  "4ru.h"
#include  "GLcolors.h"


#ifndef  STR_LEN
#define  STR_LEN  1024
#endif

extern int win_w;
extern int win_h;
extern int view;


/*------ ؿץȥ------*/
int exist_chk(char *filename);
int slur_output(FILE **fp, NOTE_NODE *cur);
int tech_output(FILE **fp, NOTE_NODE *cur);
int artic_output(FILE **fp, NOTE_NODE *cur);
double on_time2bar_time(NOTE_NODE *cur, double now_beat, int now_measure, int on_off);
/*-------------------------------------*/


int NOTEfile_write(char *org_filename, char *out_note_file, NOTE_HEADER *header_info, NOTE_NODE *top, WRITE_CTRL wctrl)
{
  FILE *fp;
  NOTE_NODE *cur;
  int counter;
  char buf[STR_LEN];
  char notefilename[STR_LEN];
  int now_beat;
  double bpm_base;
  double bar_beat;
  int measure;
  int linecont;
  char str_tmp[STR_LEN];
  int str_x_bias;



  /* koko  */
  bar_beat = 4.0;  /*  Ȥꤢ  */

  /*  note եΥե̾  */
  if(strcmp(out_note_file, "") == 0){
    if(strnicmp(strrev(org_filename), strrev(".note"), 5) == 0){
      sprintf(notefilename, "%s", org_filename);
    }else{
      sprintf(notefilename, "%s.note", org_filename);
    }
  }else{
    strcpy(notefilename, out_note_file);
  }


  while(1){
/*   if( (wctrl.ow_chk == ON) || (strcmp(out_note_file, "") == 0) ){ */
    if( (wctrl.ow_chk == ON) ){
      if(exist_chk(notefilename) == EXIST){
	br_printf(8, "%s", notefilename);
	br_printf(-1, "  ");
	c_printf(6, "overwrite ok? (y/n)\n");
	fgets(buf, STR_LEN, stdin);
	if(tolower(buf[0]) != 'y'){
	  enter_fname(notefilename, ".note");
	  if(strcmp(notefilename, "") == 0){
	    br_printf(6, "not written %s.\n", notefilename);
	    return EXIT_FAILURE;
	  }
	}else{
	  break;
	}
      }else{
	break;
      }
    }else{
      break;
    }
  }


  fp = fopen(notefilename, "w");
  if(fp == NULL){
    br_printf(2, "Can't open NOTE format file %s.\n", notefilename);
/*     exit(EXIT_FAILURE); */
    return EXIT_FAILURE;
  }

  if(wctrl.xls != ON){
    NOTEheader_write(fp, *header_info, OFF, 3, -1);
  }

  br_printf(5, "%s", notefilename);
  br_printf(-1, " Writing... ");

  str_x_bias = 200;
  if(view == ON){
    sprintf(str_tmp, "%s Writing... ", notefilename);
    put_str_large(((win_w / 2) - str_x_bias), (win_h / 2), 0, OpenGLcolors[1], str_tmp);
    glutSwapBuffers();
  }

  /*  ɽѴ  */
  switch(wctrl.out_note_format){
  case  NO_INFO:
  case  T_BEAT:  /*  TIMESCALE  BEAT ǽ񤭽Ф  */
    switch(header_info->timescale){  /*  .beat ˻ɽѴ  */
    case  T_BEAT:
      /*      on_time2bar_time(cur, bar_beat, measure, wctrl.meas) );  ĳ */
      break;

    case  T_REAL:
      real2beat(top, header_info);
      beat2q_time(top, header_info);
      break;

    case  T_DELTA:
      delta2beat(top, header_info);
      beat2q_time(top, header_info);
      break;

    case  T_MEAS:
      meas2beat(top, header_info);
      beat2q_time(top, header_info);
      break;

    default:
      br_printf(2, "%s: %d: եλɽΤ񤭽Фޤ\n",
		__FILE__, __LINE__);
      break;

    }

    break;

    /*====================================*/
  case  T_REAL:  /*  TIMESCALE  Real ǽ񤭽Ф  */
    switch(header_info->timescale){  /*  .beat ˻ɽѴ  */
    case  T_BEAT:
      beat2real(top, header_info);
      beat2q_time(top, header_info);
      break;

    case  T_REAL:
      break;

    case  T_DELTA:
      br_printf(2, "%s: %d: եλɽ Delta Τ񤭽Фޤ\n",
		__FILE__, __LINE__);
      exit(0);
      break;

    case  T_MEAS:
      br_printf(2, "%s: %d: եλɽ MEAS Τ񤭽Фޤ\n",
		__FILE__, __LINE__);
      exit(0);
      break;

    default:
      br_printf(2, "%s: %d: եλɽΤ񤭽Фޤ\n",
		__FILE__, __LINE__);
      break;

    }

    break;

    /*====================================*/
  case  T_DELTA: /*  TIMESCALE  Delta ǽ񤭽Ф  */
  case  T_MEAS:  /*  TIMESCALE  MEAS ǽ񤭽Ф  */
    br_printf(2, "%s: %d: λɽǤ note ե񤭽Фϡޤ̤Ǥ\n",
	      __FILE__, __LINE__);
    exit(0);
  }


#if 0
  cur = top;
  while(1){
    if(cur == NULL){  break; }
    print_node(cur);
/*     printf("%d\n", cur->ident); */
    cur = cur->next;
  }
  exit(0);
#endif


#if 0
  /* 1 ᤢ롥
     ⤷Header  BEAT 󤬤ʤȤϡǽ˸ҵõơ
     Ҥʬȡ1 ᤢ  */
  if( (header_info->beat_bunbo != -1) && (header_info->beat_bunsi) ){
    now_beat = header_info->beat_bunbo * header_info->beat_bunsi;
    bar_beat = (4.0 / header_info->beat_bunbo) * header_info->beat_bunsi;
  }else{
    now_beat = DEFAULT_BEAT;
    bar_beat = 4.0;
    cur = top;
    while(cur != NULL){
      if(cur->ident == BEAT){
	now_beat = cur->val[0];
	bar_beat = (4.0 / cur->val[1]) * cur->val[0];
	break;
      }
      cur = cur->next;
    }
  }
#endif

  cur = top;
  counter = 0;
  measure = 0;

  while(cur != NULL){
    linecont = OFF;
    switch(cur->ident){
    case  NOTE:
    case  REST:
      noterest_write(&fp, cur, wctrl);
      counter++;
      linecont |= slur_output(&fp, cur);
      linecont |= tech_output(&fp, cur);
      linecont |= artic_output(&fp, cur);

      fprintf(fp, "\n"); /*  ̵ѤǲԤƤ褤롥  */

/*       if(linecont == ON){ */
/* 	break; */
/*       } */
      break;

    case  BEATTIME:
      beattime_write(&fp, cur, wctrl);
      counter++;
      break;


    case  BPM:
      bpm_base = 4;  /*  ʬ  */
      if(wctrl.xls != ON){
	fprintf(fp, "%5.3f BPM %5.3f %d\n",
		on_time2bar_time(cur, bar_beat, measure, wctrl.meas),
		(double)cur->val[0] * bpm_base / 4.0,  (int)bpm_base);
      }else{
	fprintf(fp, "%5.3f BPM %5.3f %d\n",
		on_time2bar_time(cur, bar_beat, measure, wctrl.meas),
		(double)cur->val[0] * bpm_base / 4.0,  (int)bpm_base);
      }
      counter++;
      break;

    case  BEAT:
      now_beat = cur->val[1];
      bar_beat = 4.0 / cur->val[1] * cur->val[0];

      if(wctrl.xls != ON){
	fprintf(fp, "%5.3f BEAT %d / %d\n",
		on_time2bar_time(cur, bar_beat, measure, wctrl.meas),
		(int)cur->val[0],  (int)cur->val[1]);
      }else{
	fprintf(fp, "%5.3f BEAT %d / %d\n",
		on_time2bar_time(cur, bar_beat, measure, wctrl.meas),
		(int)cur->val[0],  (int)cur->val[1]);
      }
      counter++;

      break;


    case  MEASURE:
      if(wctrl.meas == OFF){
	break;
      }

      if(cur->val[0] != measure){
	if(wctrl.xls != ON){
	  fprintf(fp, "%% = %d\n",
		  (int)cur->val[0]);
	}else{
	  fprintf(fp, "%% = %d\n",
		  (int)cur->val[0]);
	}
      }

      measure = cur->val[0];
      counter++;
      break;


    case  DYNAMICS:
    case  WORDS:
    case  CRESC_DIM:
      if(strcmp(cur->str[0], "") == 0){
	break;
      }
      if(wctrl.xls != ON){
	fprintf(fp, "%% %5.3f ! \"%s\" %d",
		on_time2bar_time(cur, bar_beat, measure, wctrl.meas),
		cur->str[0], cur->staff);
	if(cur->val[0] != NO_INFO){
	  fprintf(fp, " %d", (int)cur->val[0]);
	}
	fprintf(fp, "\n");
      }else{
	fprintf(fp, "%% %5.3f ! \"%s\" %d",
		on_time2bar_time(cur, bar_beat, measure, wctrl.meas),
		cur->str[0], cur->staff);
	if(cur->val[0] != NO_INFO){
	  fprintf(fp, " %d", (int)cur->val[0]);
	}
	fprintf(fp, "\n");
      }
      counter++;
      break;


    case  DAMPER:  /*  5  */
      if(wctrl.xls != ON){
	fprintf(fp, "%5.3f Damper %d\n",
		on_time2bar_time(cur, bar_beat, measure, wctrl.meas),
		(int)cur->val[0]);
      }else{
	fprintf(fp, "%5.3f Damper %d\n",
		on_time2bar_time(cur, bar_beat, measure, wctrl.meas),
		(int)cur->val[0]);
      }
      break;



    case  SOFT:  /*  7  */
      pedal_write(&fp, cur, wctrl);
      break;


    case  BAR:  /*  9  */
      bar_write(&fp, cur, wctrl);
      counter++;
      break;


    case  DIVISIONS:
      break;
      
    case  AKIRAME:
      break;

    case  MEMO:
      break;

    case  SKIP:
      break;

    default:
      br_printf(2, "%s: %d: Unknown ident %d: %d\n", __FILE__, __LINE__, cur->ident, counter);
      printf("%s, %s, %d, %d\n", cur->str[0], cur->str[1], (int)cur->val[0],(int) cur->val[1]);
#ifdef XML
/*       xmlDebugDumpNode(stdout, cur->xmlnode, 0); */
      ;
#endif
    }
    
    cur = cur->next;
  }

  if(wctrl.xls != ON){
    fprintf(fp, "\nEND\n");
  }

  fclose(fp);

#ifdef DEBUG
  printf("%d node write.\n", counter);
#endif

  br_printf(4, "Ok!\n");
  if(view == ON){
    strcat(str_tmp, " Ok!");
    put_str_large(((win_w / 2) - str_x_bias), (win_h / 2), 0, OpenGLcolors[1], str_tmp);
    glutSwapBuffers();
  }

  return  EXIT_SUCCESS;
}



int slur_output(FILE **fp, NOTE_NODE *cur)
{
  NOTE_NODE *same;
  int slur_write;
  int i;


  slur_write = OFF;
  same = cur;
  while(1){
    if(same == NULL){  break; }

    for(i = 0; i < SLUR_NUM; i++){
      if(same->notations.slur[i].type != NO_INFO){
	if(slur_write == OFF){
	  fprintf(*fp, "  %%");
	  slur_write = ON;
	}
	
	fprintf(*fp, "  \"%s %5.3f ", same->str[0], same->len.beat);
	
	switch(same->notations.slur[i].type){
	case  START:
	  fprintf(*fp, "slur start");
	  break;
	  
	case  STOP:
	  fprintf(*fp, "slur stop");
	  break;
	  
	case  CONT:
	  fprintf(*fp, "slur cont");
	  break;
	}
	
	fprintf(*fp, " %d", same->notations.slur[i].number);
	
	if(strcmp(same->notations.slur[i].linetype, "") != 0){
	  fprintf(*fp, " %s", same->notations.slur[i].linetype);
	}
	else{
	  /* 	fprintf(*fp, " _no_info_"); */
	  ;
	}
	
	if(same->pos.def_x != NO_INFO){
	  fprintf(*fp, " %d", same->pos.def_x);
	}
	if(same->pos.def_y != NO_INFO){
	  fprintf(*fp, " %d", same->pos.def_y);
	}
	if(same->pos.rel_x != NO_INFO){
	  fprintf(*fp, " %d", same->pos.rel_x);
	}
	if(same->pos.rel_y != NO_INFO){
	  fprintf(*fp, " %d", same->pos.rel_y);
	}
	
	if(strcmp(same->place, "") != 0){
	  fprintf(*fp, " %s", same->place);
	}
	/*
	  else{
	  fprintf(*fp, " _no_info_");
	  }
	*/
	
	if(strcmp(same->notations.slur[i].orient, "") != 0){
	  fprintf(*fp, " %s", same->notations.slur[i].orient);
	}
	/*
	  else{
	  fprintf(*fp, " _no_info_");
	  }
	*/
	
	if(same->notations.slur[i].bz_offset != NO_INFO){
	  fprintf(*fp, " %d", same->notations.slur[i].bz_offset);
	}
	if(same->notations.slur[i].bz_offset2 != NO_INFO){
	  fprintf(*fp, " %d", same->notations.slur[i].bz_offset2);
	}
	
	if(same->notations.slur[i].bz_x != NO_INFO){
	  fprintf(*fp, " %d", same->notations.slur[i].bz_x);
	}
	if(same->notations.slur[i].bz_y != NO_INFO){
	  fprintf(*fp, " %d", same->notations.slur[i].bz_y);
	}
	if(same->notations.slur[i].bz_x2 != NO_INFO){
	  fprintf(*fp, " %d", same->notations.slur[i].bz_x2);
	}
	if(same->notations.slur[i].bz_y2 != NO_INFO){
	  fprintf(*fp, " %d", same->notations.slur[i].bz_y2);
	}
	
	fprintf(*fp, "\"  ");

      }
    }

    same = same->samenext;
  }

  return ON;
}


int tech_output(FILE **fp, NOTE_NODE *cur)
{
  if(stricmp(cur->notations.tech.name, "") == 0){
    return  OFF;
  }
  if(stricmp(cur->notations.tech.name, "fingering") == 0){
    return  OFF;
  }

  fprintf(*fp, "  %% %s %s %d",
	  cur->notations.tech.name, cur->notations.tech.place, cur->notations.tech.val);
  
  return  ON;
}


int artic_output(FILE **fp, NOTE_NODE *cur)
{
  if(strcmp(cur->notations.artic.name, "") == 0){
    return  OFF;
  }

  fprintf(*fp, "  %% %s %s", cur->notations.artic.name, cur->notations.artic.place);
  
  return  ON;
}


double on_time2bar_time(NOTE_NODE *cur, double bar_beat, int now_measure, int on_off)
{
  double bar_time;
  static double auf_bias;
  double on_time;
  static double pre_on_time;
  NOTE_NODE *srch;

  /* koko  */
  bar_time = 0.0;  /*  Ȥꤢ  */


  if(on_off == OFF){
    return cur->on_time.beat;
  }

  if(pre_on_time > cur->on_time.beat){
    auf_bias = 0.0;
  }
  pre_on_time = cur->on_time.beat;


  if(now_measure <= 0){
    srch = cur->next;
    while(1){
      if(srch == NULL){
	return bar_time;
      }
      if( (srch->ident == MEASURE) && (srch->val[0] > 0) ){
	auf_bias = srch->on_time.beat;
	break;
      }
      srch = srch->next;
    }
  }


  on_time = cur->on_time.beat - auf_bias;
  if(on_time < 0.0){
    bar_time = (bar_beat - ((int)floor(fabs(on_time)) % (int)bar_beat)) +
      (fabs(on_time) - floor(fabs(on_time)));
  }else{
    bar_time = ((int)floor(on_time) % (int)bar_beat) + 1.0 + (on_time - floor(on_time));
  }


  return bar_time;
}
