#include  "xml2note.h"


xmlNode *direction_analyze(xmlNode *cur, NOTE_NODE **part_cur, double *divisions, double *now_time,
			   double bar_haku, int voice)
{
  int inttmp;
  int metro_dot = 0;


  /*  Warning ΍  */
  voice = voice;

  metro_dot = 0;
  cur = cur->children;      /*  now: cur == "direction" ̂ЂƂ  */
  while(1){
    if(xmlStrcmp(cur->name, (const xmlChar *)"direction-type") == 0){
      cur = cur->children;      /*  now: cur == "direction-type" ̂ЂƂ  */
      (*part_cur)->xmlnode = cur;
      while(1){
	if(xmlStrcmp(cur->name, (const xmlChar *)"words") == 0){  /*  <words>  */
	  (*part_cur)->ident = WORDS;
	  (*part_cur)->org_xml_on_time.beat = *now_time;
	  strcpy((*part_cur)->str[0], cur->children->content);  /*  <word></word>ɋ܂ꂽ  */
	  if(xmlGetProp(cur, "relative-x") != NULL){
	    sscanf(xmlGetProp(cur, "relative-x"), "%d", &inttmp);
	    /*	    (*part_cur)->xml_on_diff = inttmp;  */
	    (*part_cur)->xml_on_diff.beat = 0; /* sort, re_divi, merge, write ̂Ƃ̂߂ on_diff ͎gȂ*/
	    (*part_cur)->org_xml_on_time.beat += inttmp;
	  }
	  /*
	  (*part_cur)->on_diff = (*part_cur)->xml_on_diff / divisions;
	  */

	  (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
	  (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions);
	  (*part_cur)->xmlnode = cur;
	  (*part_cur)->xml_step.beat = 0;

/* 	  (*part_cur)->voice = voice; */

  /*  2004-10-27  */
/* 	  (*part_cur)->next = NOTE_NODE_alloc(); */
/* 	  (*part_cur)->next->pre = (*part_cur); */
/* 	  (*part_cur) = (*part_cur)->next; */
  /*  2004-10-27  */

	}else if(xmlStrcmp(cur->name, (const xmlChar *)"metronome") == 0){  /*  <metronome>  */
	  /*
	    <!--
	    Standard metronome marks. The beat-unit values are the
	    same as for a type element, and the beat-unit-dot works
	    like the dot element. The per-minute element can
	    be a number, or a text description including numbers.
	    The parentheses attribute indicates whether or not
	    to put the metronome mark in parentheses; its value
	    is no if not specified.
	    -->
	    <!ELEMENT metronome (beat-unit, beat-unit-dot*, 
	    (per-minute | (beat-unit, beat-unit-dot*)))>
	    <!ATTLIST metronome
	    %position;
	    parentheses %yes-no; #IMPLIED
	    >
	    <!ELEMENT beat-unit (#PCDATA)>
	    <!ELEMENT beat-unit-dot EMPTY>
	    <!ELEMENT per-minute (#PCDATA)> 
	  */
	  (*part_cur)->ident = BPM;
	  cur = cur->children;  /*  now: cur == "metronome" ̂ЂƂ  */
	  while(1){
	    if(xmlStrcmp(cur->name, (const xmlChar *)"beat-unit") == 0){
	      inttmp = type2dur(cur->children->content, *divisions, bar_haku);
	      (*part_cur)->val[1] =
		16.0 * ((*divisions) / (double)inttmp);/*  l == 16 */
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"beat-unit-dot") == 0){
	      metro_dot++;
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"per-minute") == 0){
	      sscanf(cur->children->content, "%lf", &((*part_cur)->val[0]));
	      (*part_cur)->val[0] = (*part_cur)->val[0];
	    }
	    if(metro_dot == 1){
	      (*part_cur)->val[1] *= 1.5;
	    }else if(metro_dot == 2){
	      (*part_cur)->val[1] *= 1.75;
	    }

	    if(cur->next == NULL){
	      break;
	    }
	    cur = cur->next;
	  }
	  cur = cur->parent;  /*  now: cur == "metronome"  */
	  /*
	  (*part_cur)->org_xml_on_time = *now_time + inttmp;
	  */
	  (*part_cur)->org_xml_on_time.beat = *now_time;
	  (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
	  (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions);
	  (*part_cur)->xmlnode = cur;
	  (*part_cur)->xml_step.beat = 0;
	  /*
	     <sound> 邱Ƃ肵ĂD
	     tempo="?" Ƃw肪Cval[0], val[1] ɒlݒ肳D
	     (*part_cur) = (*part_cur)->next ȂD
	  (*part_cur)->next = NOTE_NODE_alloc();
	  (*part_cur)->next->pre = (*part_cur);
	  (*part_cur) = (*part_cur)->next;
	  */
	}else if(xmlStrcmp(cur->name, (const xmlChar *)"pedal") == 0){  /*  <pedal>  */
	  /*
	    <!-- 
	    Piano pedal marks. The line attribute is yes if pedal
	    lines are used, no if Ped and * signs are used. 
	    -->
	    <!ELEMENT pedal EMPTY>
	    <!ATTLIST pedal
	    type %start-stop; #REQUIRED
	    line %yes-no;	#IMPLIED
	    %position; 
	    >
	  */
	  if(strcmp(xmlGetProp(cur, "type"), "start") == 0){
	    (*part_cur)->val[0] = 127;
	  }else if(strcmp(xmlGetProp(cur, "type"), "stop") == 0){
	    (*part_cur)->val[0] = 0;
	  }
	  
	  (*part_cur)->ident = DAMPER;
	  (*part_cur)->org_xml_on_time.beat = *now_time;
	  if(xmlGetProp(cur, "relative-x") != NULL){
	    sscanf(xmlGetProp(cur, "relative-x"), "%d", &inttmp);
	    (*part_cur)->org_xml_on_time.beat += inttmp;
	  }

	  (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
	  (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions);
	  (*part_cur)->xmlnode = cur;
	  (*part_cur)->xml_step.beat = 0;

  /*  2004-10-27  */
/* 	  (*part_cur)->next = NOTE_NODE_alloc(); */
/* 	  (*part_cur)->next->pre = (*part_cur); */
/* 	  (*part_cur) = (*part_cur)->next; */
  /*  2004-10-27  */

	}else if(xmlStrcmp(cur->name, (const xmlChar *)"wedge") == 0){  /*  <wedge>  */
	  if(strcmp(xmlGetProp(cur, "type"), "crescendo") == 0){
	    strcpy((*part_cur)->str[0], "crescendo");
	  }else if(strcmp(xmlGetProp(cur, "type"), "diminuendo") == 0){
	    strcpy((*part_cur)->str[0], "diminuendo");
	  }else if(strcmp(xmlGetProp(cur, "type"), "stop") == 0){
	    strcpy((*part_cur)->str[0], "crescendo_diminuendo_stop");
	  }

	  (*part_cur)->ident = CRESC_DIM;
	  (*part_cur)->org_xml_on_time.beat = *now_time;
	  if(xmlGetProp(cur, "relative-x") != NULL){
	    sscanf(xmlGetProp(cur, "relative-x"), "%d", &inttmp);
	    (*part_cur)->org_xml_on_time.beat += inttmp;
	  }

	  (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
	  (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions);
	  (*part_cur)->xmlnode = cur;
	  (*part_cur)->xml_step.beat = 0;

  /*  2004-10-27  */
/* 	  (*part_cur)->next = NOTE_NODE_alloc(); */
/* 	  (*part_cur)->next->pre = (*part_cur); */
/* 	  (*part_cur) = (*part_cur)->next; */
  /*  2004-10-27  */
	}else if(xmlStrcmp(cur->name, (const xmlChar *)"dynamics") == 0){  /*  <dynamics>  */
	  (*part_cur)->ident = DYNAMICS;
	  (*part_cur)->org_xml_on_time.beat = *now_time;
	  (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
	  (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions);
	  (*part_cur)->xmlnode = cur;
	  (*part_cur)->xml_step.beat = 0;
	  
	  cur = cur->children;  /*  now: cur == "dynamics" ̂ЂƂ  */
	  while(1){
	    if(cur->type == XML_ELEMENT_NODE){
	      strcpy((*part_cur)->str[0], cur->name);
	    }
	    if(cur->next == NULL){
	      break;
	    }
	    cur = cur->next;
	  }
	  cur = cur->parent;

	  if(xmlGetProp(cur, "relative-x") != NULL){
	    sscanf(xmlGetProp(cur, "relative-x"), "%d", &inttmp);
	    (*part_cur)->pos.rel_x = inttmp;
	  }
	  if(xmlGetProp(cur, "placement") != NULL){
	    strcpy((*part_cur)->place, xmlGetProp(cur, "placement"));
	  }
	  /*
	    %font; ǂݔ΂
	  */
	  /*
	     <sound> 邱Ƃ肵ĂD
	     tempo="?" Ƃw肪Cval[0], val[1] ɒlݒ肳D
	     (*part_cur) = (*part_cur)->next ȂD
	  (*part_cur)->next = NOTE_NODE_alloc();
	  (*part_cur)->next->pre = (*part_cur);
	  (*part_cur) = (*part_cur)->next;
	  */

	}else{
	  ;
	}

	if(cur->next == NULL){
	  break;
	}
	cur = cur->next;
      }
      cur = cur->parent;      /*  now: cur == "direction-type"  */
    }else if(xmlStrcmp(cur->name, (const xmlChar *)"offset") == 0){
      sscanf(cur->children->content, "%d", &inttmp);
      /*
      (*part_cur)->pre->org_xml_on_time = *now_time + inttmp;
      */
      (*part_cur)->org_xml_on_time.beat += inttmp;
      (*part_cur)->xml_on_time.beat = (*part_cur)->org_xml_on_time.beat;
      (*part_cur)->on_time.beat = (*part_cur)->org_xml_on_time.beat / (*divisions);
    }else if(xmlStrcmp(cur->name, (const xmlChar *)"staff") == 0){
      sscanf(cur->children->content, "%d", &inttmp);
      (*part_cur)->staff = inttmp;
    }else if(xmlStrcmp(cur->name, (const xmlChar *)"sound") == 0){
      /* tempo, dynamics Ȃǂ́CɂD  */
      sound_analyze(cur, part_cur, divisions, *now_time);
      /*
	->pre ɑ΂đ삷
      */
      /*  velocity_apply() œKp邱Ƃɂ
      if((*part_cur)->pre->ident == DYNAMICS){
	(*part_cur)->pre->val[0] = *default_vel;
      }
      */
    }
    
    if(cur->next == NULL){
      break;
    }
    cur = cur->next;
  }
  cur = cur->parent;      /*  now: cur == "direction"  */

  /*  2004-10-27  */
  (*part_cur)->next = NOTE_NODE_alloc();
  (*part_cur)->next->pre = (*part_cur);
  (*part_cur) = (*part_cur)->next;
  /*  2004-10-27  */


#if 0
  if((*part_cur)->ident == -1){
    rc_printf(5, "koko %s\n", (*part_cur)->str[0]);
    xmlDebugDumpNode(stdout, cur->children->next, 0);
    exit(0);
  }
#endif

  return  cur;
}



/*
<!--
	Textual direction types may have more than 1 component
	due to multiple font numbers.
-->
<!ELEMENT direction-type (rehearsal+ | segno+ | words+ |
	coda+ | wedge | dynamics+ | dashes | bracket | pedal | 
	metronome | octave-shift | damp | damp-all | 
	eyeglasses | other-direction)>

<!--
	Position and font entities are based on MuseData
	print suggestions. They apply to the direction-type,
	not to the overall direction.
-->
<!ELEMENT rehearsal (#PCDATA)>
<!ATTLIST rehearsal
    %position; 
    %font;
>

<!ELEMENT words (#PCDATA)>
<!--
	Left justification is assumed if not specified. 
	Language is Italian ("it") by default.
-->
<!ATTLIST words
    justify (left | center | right) #IMPLIED
    %position; 
    %font;
    xml:lang NMTOKEN #IMPLIED
>

<!--
	Wedge spread is measured in tenths of staff line space.
	The type is crescendo for the start of a wedge that is
	closed at the left side, and diminuendo for the start
	of a wedge that is closed on the right side. Spread 
	values at the start of a crescendo wedge or end of a
	diminuendo wedge are ignored.
-->
<!ELEMENT wedge EMPTY>
<!ATTLIST wedge
    type (crescendo | diminuendo | stop) #REQUIRED
    number %beam-level; #IMPLIED
    spread CDATA #IMPLIED
    %position; 
>

<!--
	Dashes, used for instance with cresc. and dim. marks.
-->
<!ELEMENT dashes EMPTY>
<!ATTLIST dashes
    type %start-stop; #REQUIRED
    number %beam-level; #IMPLIED
    %position; 
>

<!--
	Brackets are combined with words in a variety of
	modern directions. The line-end attribute specifies
	if there is a jog up or down (or both), an arrow,
	or nothing at the start or end of the bracket.
	The line-type is solid by default.
-->

<!ELEMENT bracket EMPTY>
<!ATTLIST bracket
    type %start-stop; #REQUIRED
    number %beam-level; #IMPLIED
    line-end (up | down | both | arrow | none) #REQUIRED
	 %line-type;
    %position; 
>

<!--
	Octave shifts indicate where notes are shifted up or down
	from their true pitched values because of printing
	difficulty. Thus a treble clef line noted with 8va will
	be indicated with an octave-shift down from the pitch
	data indicated in the notes. A size of 8 indicates one
	octave; a size of 15 indicates two octaves.
-->

<!ELEMENT octave-shift EMPTY>
<!ATTLIST octave-shift
    type (up | down | stop) #REQUIRED
    number %beam-level; #IMPLIED
    size CDATA "8"
    %position; 
>

<!-- Harp damping marks -->
<!ELEMENT damp EMPTY>
<!ATTLIST damp
    %position; 
>
<!ELEMENT damp-all EMPTY>
<!ATTLIST damp-all
    %position; 
>

<!-- Eyeglasses, common in commercial music. -->
<!ELEMENT eyeglasses EMPTY>
<!ATTLIST eyeglasses
    %position; 
>


<!--
	The other-direction element is used to define
	any direction symbols not yet in the current version
	of MusicXML. This allows extended representation,
	though without application interoperability.
-->
<!ELEMENT other-direction (#PCDATA)>
<!ATTLIST other-direction
    %position; 
>

*/
