/*  Time-stamp: <2005-04-14 17:42:36 >  */
#include  "4ru.h"

void disp_gttm_value(int chk_mode, char *arg_file, NOTE_NODE *cur, char gttm_line[STR_LEN])
{
  NOTE_NODE *srch;
  static char gpr_str[GPR_NUM][NODE_STR_LEN] = {
    "1",
    "2a",
    "2b",
    "3a",
    "3b",
    "3c",
    "3d",
    "4",
    "5",
    "6",
  };

  int i;


  if(cur->next->next != NULL){
    fprintf(stderr, "%s  ------\n", arg_file);
    switch(chk_mode){
    case  Henle: /* Henle  check*/
      srch = cur->pre;
      while(1){
	if(srch == NULL){  break; }
	if(stricmp(srch->str[1], gttm_line) == 0){
	  fprintf(stderr, "%s  %5.3f  ", srch->str[0], srch->len.beat);
	  for(i = GPR2a; i <= GPR3d; i++){
/* 	    if(i == GPR3a){  continue; } */
/* 	    if(i == GPR3c){  continue; } */
/* 	    if(i == GPR3d){  continue; } */
	    fprintf(stderr, "%s: %5.3f ", gpr_str[i], srch->GPR[i]);
	    if(srch->GPR_PERSON[YT][i] == ON){
	      fprintf(stderr, "H ");
	    }else{
	      fprintf(stderr, "P ");
	    }
	    if(srch->GPR_PERSON[MH][i] == ON){
	      fprintf(stderr, "H  ");
	    }else{
	      fprintf(stderr, "P  ");
	    }
	  }
	  break;
	}
	srch = srch->samenext;
      }
      fprintf(stderr, "\n");
      fprintf(stderr, "\n");
      
      break;

    case  Peters:  /* Peters  check*/
      srch = cur->next;
      while(1){
	if(srch == NULL){  break; }
	if(stricmp(srch->str[1], gttm_line) == 0){
	  fprintf(stderr, "%s  %5.3f  ", srch->str[0], srch->len.beat);
	  for(i = GPR2a; i <= GPR3d; i++){
/* 	    if(i == GPR3a){  continue; } */
/* 	    if(i == GPR3c){  continue; } */
/* 	    if(i == GPR3d){  continue; } */
	    fprintf(stderr, "%s: %5.3f  ", gpr_str[i], srch->GPR[i]);
	    if(srch->GPR_PERSON[YT][i] == ON){
	      fprintf(stderr, "H ");
	    }else{
	      fprintf(stderr, "P ");
	    }
	    if(srch->GPR_PERSON[MH][i] == ON){
	      fprintf(stderr, "H  ");
	    }else{
	      fprintf(stderr, "P  ");
	    }
	  }
	  break;
	}
	srch = srch->samenext;
      }
      fprintf(stderr, "\n");
      fprintf(stderr, "\n");
      
      break;


    default:
      break;
    }
  }
}
/*  ʤλĳ  */
#if 0
    srch = cur->pre->pre;
    while(1){
      if(srch == NULL){  break; }
      if(stricmp(srch->str[1], gttm_line) == 0){
	fprintf(stderr, "%s  %5.3f  ", srch->str[0], srch->len.beat);
	for(i = GPR2a; i <= GPR3d; i++){
	  fprintf(stderr, "%5.3f  ", srch->GPR[i]);
	}
	break;
		}
      srch = srch->samenext;
    }
    fprintf(stderr, "\n");
#endif
/*  ʤλĳ  */
