#include  "4ru.h"

extern int win_w;

/*  GPR3 change
    GPR3b dynamics  */
int gpr3b(NOTE_NODE *linetop)
{
  NOTE_NODE *cur;
  NOTE_NODE *n[4];
  int dyn_diff12;
  int dyn_diff23;
  int dyn_diff34;

  double dyn_diff12_bias;
  double dyn_diff34_bias;


  cur = linetop;

  while(1){
    if(cur->draw_xs >= (win_w + 128) ){  return  EXIT_SUCCESS; }
    dyn_diff12_bias = 0.0;
    dyn_diff34_bias = 0.0;

    if(get_n4(cur, n, -1) == EXIT_FAILURE){  return  EXIT_SUCCESS;  }
    /*
      n1 : n[0]
      n2 : n[1]
      n3 : n[2]
      n4 : n[3]
    */

    /*  ȂCΒlɂȂ̂낤H  */
/*     dyn_diff12 = n[1]->val[ON_VEL] - n[0]->val[ON_VEL]; */
/*     dyn_diff23 = n[2]->val[ON_VEL] - n[1]->val[ON_VEL]; */
/*     dyn_diff34 = n[3]->val[ON_VEL] - n[2]->val[ON_VEL]; */

    dyn_diff12 = abs(n[1]->val[ON_VEL] - n[0]->val[ON_VEL]);
    dyn_diff23 = abs(n[2]->val[ON_VEL] - n[1]->val[ON_VEL]);
    dyn_diff34 = abs(n[3]->val[ON_VEL] - n[2]->val[ON_VEL]);

    n[1]->GPR[GPR3b] = (dyn_diff23 - dyn_diff12) + (dyn_diff23 - dyn_diff34);

    if((dyn_diff23 > (dyn_diff12 + dyn_diff12_bias)) &&
       (dyn_diff23 > (dyn_diff34 + dyn_diff34_bias))){
      n[1]->GPR_ON_OFF[GPR3b] = ON;
    }else{
      n[1]->GPR_ON_OFF[GPR3b] = OFF;
    }

    if(n[1]->org_node != NULL){
      n[1]->org_node->GPR[GPR3b] = n[1]->GPR[GPR3b];
      n[1]->org_node->GPR_ON_OFF[GPR3b] = n[1]->GPR_ON_OFF[GPR3b];
    }

    cur = cur->next;
  }

  return  EXIT_SUCCESS;
}
