/* Time-stamp: <2005-05-19 18:32:26 >  */
#include  "4ru.h"


extern NOTE_NODE *note_bot;
extern NOTE_NODE *view_note_cur;
extern NOTE_NODE *note_top;
extern char gttm_line[STR_LEN];
extern int gttm_exec;
extern int RTgpr_mode;



int gttm(char *gttm_dir)
{
/* #define  DEB */
#ifdef DEB
  static char *filelist[B_FILE_NUM];
  static NOTE_NODE *b_top[B_FILE_NUM];
  static NOTE_HEADER b_header_info[B_FILE_NUM];
  int filelist_len;
  char fullpathfile[STR_LEN];
#endif

  static NOTE_NODE *linetop = NULL;
  static double gpr_th[GPR_PERSON_NUM][GPR_NUM];
  NOTE_NODE *cur = NULL;
  NOTE_NODE *same = NULL;
  int i;
  int j;

  gttm_dir = gttm_dir;

/*======  H, H- Ő؂Ƃ̕ϒl  ======*/
/*   gpr_th[YT][GPR2a] =  0.110; */
/*   gpr_th[YT][GPR2b] = -1.000; */
/*   gpr_th[YT][GPR3a] =  8.000;   /\*  K.331 Peters ̏ꍇ́C̕]l 8  *\/ */
/*   gpr_th[YT][GPR3b] =  0.000; */
/*   gpr_th[YT][GPR3c] =  0.000; */
/*   gpr_th[YT][GPR3d] =  0.000; */

/*   gpr_th[MH][GPR2a] =  0.050; */
/*   gpr_th[MH][GPR2b] = -1.032; */
/*   gpr_th[MH][GPR3a] =  8.000; */
/*   gpr_th[MH][GPR3b] = -5.268; */
/*   gpr_th[MH][GPR3c] =  0.000; */
/*   gpr_th[MH][GPR3d] =  0.000; */

/*======  H, H- Ő؂ȂƂ̕ϒl  ======*/
/*  Ƃ  */
/*======  P, P- Ő؂Ƃ̕ϒl  ======*/
/*  Ƃ  */

/*======  P Ő؂Ƃ̕ϒl  ======*/
/*   gpr_th[YT][GPR2a] =  0.5595; */
/*   gpr_th[YT][GPR2b] =  0.8293; */
/*   gpr_th[YT][GPR3a] = -8.000;  /\*  K.331 Peters ̏ꍇ́C̕]l -8  *\/ */
/*   gpr_th[YT][GPR3b] = 38.600;  /\*  Dynamics  *\/ */
/*   gpr_th[YT][GPR3c] =  0.000;  /\*  Articulation  *\/ */
/*   gpr_th[YT][GPR3d] =  0.125;  /\*  Len  *\/ */

/*   gpr_th[MH][GPR2a] =  0.680; */
/*   gpr_th[MH][GPR2b] =  0.808; */
/*   gpr_th[MH][GPR3a] = -8.000;  /\*  K.331 Peters ̏ꍇ́C̕]l -8  *\/ */
/*   gpr_th[MH][GPR3b] = 29.667;  /\*  Dynamics  *\/ */
/*   gpr_th[MH][GPR3c] =  0.000;  /\*  Articulation  *\/ */
/*   gpr_th[MH][GPR3d] =  0.125;  /\*  Len  *\/ */

/*======  H,H- Ő؂Ƃ P,P- Ő؂ȂƂ̂ꂼ̕ϒl̒Ԓl ======*/
/*  (SIGMUS2004-11 Ŏgp  */
  gpr_th[YT][GPR2a] = -0.019;
  gpr_th[YT][GPR2b] = -1.009;
  gpr_th[YT][GPR3a] =  8.000;
/*   gpr_th[YT][GPR3b] = -0.082;  /\*   127 Ŋl  *\/ */
  gpr_th[YT][GPR3b] =-10.371;
  gpr_th[YT][GPR3c] =  0.000;
  gpr_th[YT][GPR3d] =  0.1875;

  gpr_th[MH][GPR2a] = -0.135;
  gpr_th[MH][GPR2b] = -1.004;
  gpr_th[MH][GPR3a] =  8.000;
/*   gpr_th[MH][GPR3b] = -0.102;  /\*   127 Ŋl  *\/ */
  gpr_th[MH][GPR3b] =-12.991;
  gpr_th[MH][GPR3c] =  0.000;
  gpr_th[MH][GPR3d] =  0.1875;
  /*==================================================================*/

  /*   linetop = get_note_line(arg_top, "m0"); */
  /*   linetop = get_note_line(view_note_cur, gttm_line); */

  if(linetop == NULL){
/*     linetop = get_note_line(note_top, gttm_line, -1); */
    linetop = get_note_line(note_top, gttm_line, REST);
    if(linetop == NULL){
      exit(EXIT_FAILURE);
    }
  }else if(RTgpr_mode == ON){
    linetop = note_top;
  }


  cur =linetop;
  while(cur != NULL){
    same = cur;
    while(same != NULL){
      for(i = GPR1; i < GPR6; i++){
	cur->pre_GPR[i] = cur->GPR[i];
	cur->pre_GPR_ON_OFF[i] = cur->GPR_ON_OFF[i];
	cur->GPR_ON_OFF[i] = OFF;
	cur->GPR[i] = -32768;
      }
      cur->GPR_ON_OFF[GPR1] = -128;
      for(i = 0; i < GPR_PERSON_NUM; i++){
	for(j = 0; j < GPR_NUM; j++){
	  cur->pre_GPR_PERSON[i][j] = cur->GPR_PERSON[i][j];
	  cur->GPR_PERSON[i][j] = OFF;
	}
      }
      same = same->samenext;
    }
    if(cur == note_bot){  break; }
    cur = cur->next;
  }

/*   notelist_display(linetop); */

  gpr2a(linetop);
  gpr2b(linetop);
  gpr3a(linetop);
  gpr3b(linetop);
  gpr3c(linetop);
  gpr3d(linetop);


#if 0
  cur = linetop;
  while(1){
    if(cur == NULL){  break; }
    printf("GPR3b: %5.3f\n", cur->GPR[GPR3b]);
    cur = cur->next;
  }
#endif

  /* ====== GPR2, 3 ɂāClƂɈقȂ臒l ====== */
  cur = linetop;
  while(cur != NULL){
    same = cur;
    while(same != NULL){
/*       for(j = 0; j < GPR_PERSON_NUM; j++){ */
/* 	for(i = GPR2a; i <= GPR3d; i++){ */
/* /\* 	  printf("th: %5.3f vs %5.3f\n", gpr_th[j][i], same->GPR[i]); *\/ */
/* 	  if(same->GPR[i] >= gpr_th[j][i]){ */
/* 	    same->GPR_PERSON[j][i] = ON; */
/* 	  } */
/* 	} */

	for(i = GPR2a; i <= GPR3d; i++){
	  if(same->GPR[i] > gpr_th[YT][i]){
	    same->GPR_PERSON[YT][i] = ON;
	    if(same->org_node != NULL){
	      same->org_node->GPR_PERSON[YT][i] = ON;
	    }
	  }else{
	    same->GPR_PERSON[YT][i] = OFF;
	    if(same->org_node != NULL){
	      same->org_node->GPR_PERSON[YT][i] = OFF;
	    }
	  }

	  if(same->GPR[i] > gpr_th[MH][i]){
	    same->GPR_PERSON[MH][i] = ON;
	    if(same->org_node != NULL){
	      same->org_node->GPR_PERSON[MH][i] = ON;
	    }
	  }else{
	    same->GPR_PERSON[MH][i] = OFF;
	    if(same->org_node != NULL){
	      same->org_node->GPR_PERSON[MH][i] = OFF;
	    }
	  }
/* 	} */
      }
      if(same == note_bot){  break; }
      same = same->samenext;
    }
    if(cur == note_bot){  break; }
    cur = cur->next;
  }


  /* ====== GPR1 ȍ~́C ====== */
/*   gpr1(linetop);  /\*  avoid single event  *\/ */
/*   gpr4(linetop);  /\*  Intensification  *\/ */
  gpr5(linetop);  /*  symmetry  */
/*   h_gpr6(linetop);  /\*  parallelism  *\/ */
  gpr6(linetop);  /*  parallelism  */


/*   view_note_cur = linetop; */


  return EXIT_SUCCESS;
}
