/* Time-stamp: <2005-05-19 09:10:21 >  */
#include  "normal_dist.h"


double std_normal_dist(double x)
{
  return  normal_dist(0.0, 1.0, x);
}

/*
  u: σ
  s: UЁH
  x: W
 */
double normal_dist(double u, double s, double x)
{
  return
    1.0 /
    (sqrt(2.0 * M_PI) * s) *
    exp(-((x - u) * (x - u)) / (2 * s * s));
}
