#include  "NOTEfile.h"
#include  "disp_errline.h"


int note_bar_parse(FILE *fp, char *filename,
		   int line, char linebuf[], int *idx, char token[],
		   NOTE_NODE *cur)
{

  fp = fp;


  cur->ident = BAR;

  get_token(linebuf, idx, token);
  if(strcmp(token, " ") == 0){
    get_token(linebuf, idx, token);  /*  ʸɤФ  */
  }

  if(sscanf(token, "%lf", &(cur->val[0])) != 1){
    disp_errline(filename, line, linebuf, *idx, "ֹ椬ʤ");
    fclose(fp);
    exit(EXIT_FAILURE);
  }

  while(1){
    get_token(linebuf, idx, token);
    if(strcmp(token, "") == 0){  /*  ʸä齪λ  */
      return EXIT_SUCCESS;
    }

    if(strcmp(token, " ") == 0){
      get_token(linebuf, idx, token);  /*  ʸɤФ  */
    }

    if(strcmp(token, "|:") == 0){
      cur->val[BAR_REPEAT_S] = ON;
    }else if(strcmp(token, ":|") == 0){
      cur->val[BAR_REPEAT_E] = ON;
    }else if(strcmp(token, "||") == 0){
      cur->val[BAR_REPEAT_ALL_E] = ON;
    }else if(strcmp(token, ":||:") == 0){
      disp_errline(filename, line, linebuf, *idx, "\":|\"  \"|:\" δ֤˶ʸ񤤤Ƥ");
      fclose(fp);
      exit(EXIT_FAILURE);
    }else{  /*  ʳä鹽ʸ顼  */
      return EXIT_FAILURE;
    }
  }

  get_token(linebuf, idx, token);

  /*
  printf("\nbar: %d\n", (int)cur->val[0]);
  */

  return EXIT_SUCCESS;
}
