#include  "xml2note.h"



xmlNode *part_analyze(xmlNode *cur, int part_idx, NOTE_NODE *part_top[PART_NUM], double now_divi[PART_NUM],
		         int default_vel[PART_NUM], ARTI_DUR *arti_dur, int *m_line_base, DRUM_DEF *drum_data)
{
  static int measure[PART_NUM];
  NOTE_NODE *part_cur[PART_NUM];
  NOTE_NODE *srch;
  int inttmp;
  int i;
  double now_time;
  double pre_duration;
  double dur_duration;
  double max_now_time;
  /*  double m0_bias;  */
  double backup_duration;
  double forward_duration;
  int beat_bunbo;
  int beat_bunsi;
  double bar_haku;
  int m_line;
  int m_line_max;
  int now_voice;
  xmlNode *tmp_parent = NULL;
  xmlNode *tmp_measure = NULL;


  m_line_max = 0;
  now_voice = 1;

  for(i = 0; i < PART_NUM; i++){
    part_cur[i] = part_top[i];
  }
  
  /*  now: cur == "part"  */

  cur = cur->children;  /*  now: cur == ("part" ̈̑w)  */

  
  now_time = 0;
  pre_duration = 0;
  dur_duration = 0;
  max_now_time = 0;
  beat_bunbo = 4;
  beat_bunsi = 4;
  bar_haku = (4.0 / beat_bunbo) * beat_bunsi;  /*  4  4 q  */
  while(cur != NULL){
    if(cur->type == XML_ELEMENT_NODE){
      if(xmlStrcmp(cur->name, (const xmlChar *)"measure") == 0){	/*  <measure>  */
	sscanf(xmlGetProp(cur, "number"), "%d", &inttmp);
	part_cur[part_idx]->val[0] = inttmp;
	/*
	if(inttmp != (measure[part_idx] + 1) ){
	  br_printf(2, "%d ߖڂȂH\n", (measure[part_idx] + 1));
	  }
	*/

	measure[part_idx] += 1;
/* 	part_cur[part_idx]->ident = MEASURE; */
	part_cur[part_idx]->ident = BAR;
	now_time = max_now_time;
	max_now_time = 0;

	part_cur[part_idx]->org_xml_on_time.beat = now_time;
	part_cur[part_idx]->xml_on_time.beat = now_time;
	part_cur[part_idx]->on_time.beat = now_time / now_divi[part_idx];
	part_cur[part_idx]->xmlnode = cur;
	part_cur[part_idx]->xml_step.beat = 0;

	part_cur[part_idx]->next = NOTE_NODE_alloc();
	part_cur[part_idx]->next->pre = part_cur[part_idx];
	part_cur[part_idx] = part_cur[part_idx]->next;

	tmp_measure = cur;
	cur = cur->children;  /*  now: cur == ("measure" ̈̑w)  */

	while(cur != NULL){
	  if(cur->type == XML_ELEMENT_NODE){
	    if(xmlStrcmp(cur->name, (const xmlChar *)"attributes") == 0){	/*  <attributes>  */
	      tmp_parent = cur;
	      cur = cur->children;  /*  now: cur == ("attributes" ̈̑w)  */
	      while(cur != NULL){
		if(cur->type == XML_ELEMENT_NODE){
		  if(xmlStrcmp(cur->name, (const xmlChar *)"divisions") == 0){	/*  <divisions>  */
		    part_cur[part_idx]->ident = DIVISIONS;
		    part_cur[part_idx]->org_xml_on_time.beat = now_time;
		    part_cur[part_idx]->xml_on_time.beat = now_time;
		    part_cur[part_idx]->on_time.beat = now_time / now_divi[part_idx];
		    part_cur[part_idx]->xmlnode = cur;
		    part_cur[part_idx]->xml_step.beat = 0;

		    sscanf(cur->children->content, "%lf", &(part_cur[part_idx]->val[0]) );
		    now_divi[part_idx] = part_cur[part_idx]->val[0];

		    part_cur[part_idx]->next = NOTE_NODE_alloc();
		    part_cur[part_idx]->next->pre = part_cur[part_idx];
		    part_cur[part_idx] = part_cur[part_idx]->next;
		  }else if(xmlStrcmp(cur->name, (const xmlChar *)"key") == 0){	/*  <key>  */
		    ;  /*  ЂƂ܂ "key" ̏́CȂ  */
		  }else if(xmlStrcmp(cur->name, (const xmlChar *)"time") == 0){	/*  <time>  */
		    part_cur[part_idx]->ident = BEAT;
		    part_cur[part_idx]->org_xml_on_time.beat = now_time;
		    part_cur[part_idx]->xml_on_time.beat = now_time;
		    part_cur[part_idx]->on_time.beat = now_time / now_divi[part_idx];
		    part_cur[part_idx]->xmlnode = cur;
		    part_cur[part_idx]->xml_step.beat = 0;

		    /*  time  symbol `FbN邱Ƃ́C蔲  */
		    /*
		      <!ELEMENT time ((beats, beat-type)+ | senza-misura)>
		      <!ATTLIST time
		      symbol (common | cut | single-number | normal) #IMPLIED
		    */

		    cur = cur->children;  /*  now: cur == ("time" ̈̑w)  */
		    while(cur != NULL){
		      if(cur->type == XML_ELEMENT_NODE){
			if(xmlStrcmp(cur->name, (const xmlChar *)"beats") == 0){ /*  <beats> q  */
			  sscanf(cur->children->content, "%lf", &(part_cur[part_idx]->val[0]));
			  beat_bunsi = part_cur[part_idx]->val[0];
			}else if(xmlStrcmp(cur->name, (const xmlChar *)"beat-type") == 0){/*<beat-type>*/
			  sscanf(cur->children->content, "%d", &inttmp);
			  beat_bunbo = inttmp;
			  part_cur[part_idx]->val[1] = inttmp;
			  bar_haku = (4.0 / beat_bunbo) * beat_bunsi;
			}
		      }
		      if(cur->next == NULL){
			break;
		      }
		      cur = cur->next;
		    }
		    cur = cur->parent;  /*  now: cur == "time"  */

		    part_cur[part_idx]->next = NOTE_NODE_alloc();
		    part_cur[part_idx]->next->pre = part_cur[part_idx];
		    part_cur[part_idx] = part_cur[part_idx]->next;
		  }else if(
			   (xmlStrcmp(cur->name, (const xmlChar *)"clef") == 0) ||	/*  <clef>  */
			   (xmlStrcmp(cur->name, (const xmlChar *)"staves") == 0) 
			   ){
		    ;  /*  ЂƂ܂CȂ  */
		  }else{
		    br_printf(3, "%s: %d: Skip: attributes: %s is unsupported. (XML line: %d)\n",
			      __FILE__, __LINE__, cur->name, xmlGetLineNo(cur));
/* 		    xmlDebugDumpNode(stdout, cur, 0); */
		  }
		}
		if(cur->next == NULL){
		  break;
		}
		cur = cur->next;
	      }
	      cur = tmp_parent;    /*  now: cur == "attributes"  */
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"sound") == 0){	/*  <sound>  */
	      /* tempo, dynamics Ȃǂ́CɂD  */
		sound_analyze(cur, &(part_cur[part_idx]), &(now_divi[part_idx]), now_time);
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"note") == 0){	/*  <note>  */
	      part_cur[part_idx]->ident = NOTE;
	      xmlnote_analyze(cur, &(part_cur[part_idx]), now_divi[part_idx],
			      &now_time, &pre_duration, default_vel, bar_haku, beat_bunbo, arti_dur, *m_line_base, &m_line, part_idx,
			      drum_data);
/* 	      now_voice = part_cur[part_idx]->voice; */
	      if(m_line_max < m_line){
		m_line_max = m_line;
	      }
	      part_cur[part_idx]->org_xml_on_time.beat = now_time;
	      part_cur[part_idx]->xml_on_time.beat = now_time;
	      part_cur[part_idx]->on_time.beat = now_time / now_divi[part_idx];
	      part_cur[part_idx]->xmlnode = cur;
	      part_cur[part_idx]->xml_step.beat = pre_duration;
	      
	      now_time += pre_duration;
	      if(max_now_time < now_time){
		max_now_time = now_time;
	      }
	      
	      part_cur[part_idx]->next = NOTE_NODE_alloc();
	      part_cur[part_idx]->next->pre = part_cur[part_idx];
	      part_cur[part_idx] = part_cur[part_idx]->next;
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"backup") == 0){	/*  <backup>  */
	      backup_duration = -1;
/* 	      now_voice++; */
	      tmp_parent = cur;
	      cur = cur->children;
	      while(cur != NULL){
		if(xmlStrcmp(cur->name, (const xmlChar *)"duration") == 0){	/*  <duration>  */
		  sscanf(cur->children->content, "%lf", &backup_duration);
		}
		if(cur->next == NULL){
		  break;
		}
		cur = cur->next;
	      }
	      cur = tmp_parent;
	      if(backup_duration == -1){
		br_printf(2, "<backup>  <duration> 擾Ɏs܂D\n");
		exit(EXIT_FAILURE);
	      }

	      now_time -= backup_duration;

	      srch = part_cur[part_idx];
	      while(1){
		if(srch->pre == NULL){
		  break;
		}
		srch = srch->pre;

		if( (srch->ident == NOTE) ||
		    (srch->ident == REST) ){
		  srch->xml_step.beat += pre_duration;/* step ́C̃m[h̏񂪊m肵Ƃɑ邩*/
		  srch->xml_step.beat -= backup_duration;
		  break;
		}
	      }
	      /*
		if(srch->pre != NULL){
		  if(srch->pre->xml_step <= 0){
		    srch->pre->xml_step += pre_duration;
		    srch->pre->xml_step -= dur_duration;
		  }else{
		    srch->pre->xml_step -= dur_duration;
		  }
		}
	      */
	      
	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"forward") == 0){	/*  <forward>  */
	      /*
	      part_cur[part_idx]->xml_step = pre_duration;
	      */
	      forward_duration = -1;
	      cur = cur->children;
	      while(cur != NULL){
		if(xmlStrcmp(cur->name, (const xmlChar *)"duration") == 0){	/*  <duration>  */
		  sscanf(cur->children->content, "%lf", &forward_duration);
		}
		if(cur->next == NULL){
		  break;
		}
		cur = cur->next;
	      }
	      cur = cur->parent;
	      if(forward_duration == -1){
		br_printf(2, "<forward>  <duration> 擾Ɏs܂D\n");
		exit(EXIT_FAILURE);
	      }

	      now_time += forward_duration;
	      if(max_now_time < now_time){
		max_now_time = now_time;
	      }

	      srch = part_cur[part_idx];
	      while(1){
		if(srch->pre == NULL){
		  break;
		}
		srch = srch->pre;

		if( (srch->ident == NOTE) ||
		    (srch->ident == REST) ){
		  srch->xml_step.beat += pre_duration;/* step ́C̃m[h̏񂪊m肵Ƃɑ邩*/
		  srch->xml_step.beat += forward_duration;
		  break;
		}
	      }
	      /*
	      if(part_cur[part_idx]->pre != NULL){
		if(part_cur[part_idx]->pre->xml_step <= 0){
		  part_cur[part_idx]->pre->xml_step += pre_duration;
		  part_cur[part_idx]->pre->xml_step += dur_duration;
		}else{
		  part_cur[part_idx]->pre->xml_step += dur_duration;
		}
	      }
	      */

	    }else if(xmlStrcmp(cur->name, (const xmlChar *)"direction") == 0){	/*  <direction>  */
	      /*
		part_cur[part_idx]->ident ́Cdirection_analyze() ̒Ō܂D
	      */
	      /*
	      part_cur[part_idx]->org_xml_on_time = now_time;
	      part_cur[part_idx]->xml_on_time = now_time;
	      part_cur[part_idx]->on_time = now_time / now_divi[part_idx];
	      part_cur[part_idx]->xmlnode = cur;
	      */

	      direction_analyze(cur, &(part_cur[part_idx]), &(now_divi[part_idx]), &now_time, bar_haku, now_voice);
	      /*  alloc()  cur = cur->next ́Cdirection_analyze() ̒ōsĂD  */
	    }else if(
		     (xmlStrcmp(cur->name, (const xmlChar *)"barline") == 0) ||
		     (xmlStrcmp(cur->name, (const xmlChar *)"print") == 0)
		     ){
	      ;  /*  ЂƂ܂CȂ  */
	    }else{
	      br_printf(2, "%s: %d: Unknown: measure: %s(XML line: %d)\n",
		  __FILE__, __LINE__, cur->name, xmlGetLineNo(cur));
/* 	      xmlDebugDumpNode(stdout, cur, 0); */
/* 	      exit(0); */
	      br_printf(2, "łȂ^O܂Cđs܂\n");
	    }
	  }
	  if(cur->next == NULL){
	    break;
	  }
	  cur = cur->next;
	}

	cur = tmp_measure;  /*  now: cur == "measure"  */
      }else{
	br_printf(2, "%s: %d: koko: %s (XML line: %d)\n",
		  __FILE__, __LINE__, cur->name, xmlGetLineNo(cur));
	xmlDebugDumpNode(stdout, cur, 0);
/* 	exit(0); */
      }
    }
    if(cur->next == NULL){
      break;
    }
    cur = cur->next;
  }

  *m_line_base = m_line_max;

  cur = cur->parent; /*  now: cur == "part"  */
  cur = cur->next;   /*  now: cur == ("part"  next m[h)  */


  if(part_cur[part_idx]->pre != NULL){
    part_cur[part_idx] = part_cur[part_idx]->pre;
    free(part_cur[part_idx]->next);
    part_cur[part_idx]->next = NULL;
  }else{
    printf("%s: %d: koko\n", __FILE__, __LINE__);
    free(part_cur[part_idx]);
    part_cur[part_idx] = NULL;
  }


  return cur;
}
