#include  "xml2note.h"
#include  <limits.h>


/*------ $BFbIt4X?t%W%m%H%?%$%W@k8@(B------*/
static int get_min_node(NOTE_NODE *part_cur[PART_NUM], int part_num);
/*-------------------------------------*/

extern NOTE_NODE *note_bot;
extern NOTE_NODE *note_alc;
extern NOTE_HEADER note_header_info;

extern NOTE_NODE *view_note_cur;



NOTE_NODE *part_merge(NOTE_NODE *part_top[PART_NUM], int part_num)
{
  NOTE_NODE *part_cur[PART_NUM];
  NOTE_NODE *merge_top;
  NOTE_NODE *merge_cur;
  NOTE_NODE *pre;
  int i;


/*   part_sort(part_top, part_num);  /\*  koko  *\/ */

  for(i = 0; i < PART_NUM; i++){
    part_cur[i] = part_top[i];
  }

  merge_top = NOTE_NODE_alloc();
  merge_cur = merge_top;

  while(1){
    i = get_min_node(part_cur, part_num);
    if(i == -1){  break; }
/*     *merge_cur = *part_cur[i]; */
    pre = merge_cur->pre;
    memcpy(merge_cur, part_cur[i], sizeof(*part_cur[i]));
    merge_cur->xml_org_node = part_cur[i];
    part_cur[i]->to_note_node = merge_cur;
    merge_cur->pre = pre;
    merge_cur->next = NOTE_NODE_alloc();
    merge_cur->next->pre = merge_cur;
    merge_cur = merge_cur->next;
    part_cur[i] = part_cur[i]->next;
  }

  if(merge_cur->pre != NULL){
    merge_cur = merge_cur->pre;
    free(merge_cur->next);
  }
  merge_cur->next = NULL;
  note_bot = merge_cur;
  note_alc = merge_cur;
  view_note_cur = merge_top;

#if 0
  merge_cur = merge_top;
  while(merge_cur->next != NULL){
    printf("%f\n", merge_cur->on_time);
    if(merge_cur->on_time > merge_cur->next->on_time){
      printf(">\n");
      exit(-1);
    }
    merge_cur = merge_cur->next;
  }
  printf("merge Ok\n");
#endif


  return merge_top;
}


static int get_min_node(NOTE_NODE *part_cur[PART_NUM], int part_num)
{
  int i;
  double min;
  int min_i;


  min = (double)INT_MAX;
  min_i = -1;
  for(i = 0; i < part_num; i++){
    if(part_cur[i] == NULL){  continue; }
/*     if(min > part_cur[i]->xml_on_time.beat){  /\*  koko  .beat $B$GBg>fIW!)(B  *\/ */
/*       min = part_cur[i]->xml_on_time.beat; */
    if(min > part_cur[i]->on_time.beat){  /*  koko  .beat $B$GBg>fIW!)(B  */
      min = part_cur[i]->on_time.beat;
      min_i = i;
    }
  }


  return min_i;
}
