/*  Time-stamp: <2005-08-30 05:04:49 >  */
#include  "xml2note.h"

/*
#define DIVISHOW  1
*/

static int allpart_redivi(xmlNode *top, int re_divi);
static int part_redivi(xmlNode *top, int re_divi, double *mul);

int re_division(NOTE_NODE *part_top[PART_NUM], int part_num, xmlDoc *xml_doc_top, int re_divi)
{
  NOTE_NODE *part_cur;
  int part_idx;
  double mul;
  double now_divi;
  double now_time;
  int beat_bunbo = 4;  /*  l̎lqftHglƂ  */
  /*
  NOTE_NODE *srch;
  double chk_time;
  double max_time;
  int i;
  */
  double pre_org_xml_on_time;
  double step;
  int re_divi_flag;
  xmlNode *xml_top;
  /*
  xmlNode *xml_cur;
  xmlChar xmlchartmp[STR_LEN];
  */

#ifdef DIVISHOW
  printf("re divisioning: ");
#endif


#if 0
  for(i = 0; i < part_num; i++){
    part_cur = part_top[i];
    while(1){
      if(part_cur->next == NULL){  break; }
      printf("org: %f\n", part_cur->org_xml_on_time);
      part_cur = part_cur->next;
    }
  }
  exit(0);
#endif

  /*
    V division l re_divi Ŏw肳ĂȂC
       division l̍ŏ{ re_divi ɐݒ肷D
  */
  re_divi_flag = OFF;
  if(re_divi <= 0){
    re_divi = 1;
    for(part_idx = 0; part_idx < part_num; part_idx++){
      part_cur = part_top[part_idx];
      while(part_cur != NULL){
	if(part_cur->ident == DIVISIONS){
#if defined(DIVISHOW) == 1
	  printf("%d ", part_cur->val[0]);
#endif
	  re_divi = lcm(re_divi, part_cur->val[0]);
	  if(re_divi != part_cur->val[0]){
	    re_divi_flag = ON;
	  }
	}
	part_cur = part_cur->next;
      }
    }
#if defined(DIVISHOW) == 1
    printf("\n");
#endif
  }else{
    re_divi_flag = ON;
  }
  
  /* re_divi ōČvZ  */
#if defined(DIVISHOW) == 1
  printf("re_divi: %d\n", re_divi);
#endif

  if(re_divi_flag == ON){
    br_printf(6, "divisions  %d ɕϊ܂D  ", re_divi);
  }

  /*
  XML ׂ̂Ă <duration> <relative-x> Ȃǂ redivisioning 
  */
  xml_top = xmlDocGetRootElement(xml_doc_top);
  allpart_redivi(xml_top, re_divi);
  xmlSetTreeDoc(xml_top, xml_doc_top);
  

  /* ------  org_xml_on_time ŌvZR[hC ------ */
  for(part_idx = 0; part_idx < part_num; part_idx++){
    part_cur = part_top[part_idx];
    now_time = 0;
    now_divi = re_divi;
    pre_org_xml_on_time = 0;
    mul = 1.0;
    while(1){
      if(part_cur->ident == DIVISIONS){
	now_divi = part_cur->val[0];
	mul = re_divi / now_divi;
	part_cur->val[0] = re_divi;
      }

      if(part_cur->ident == BEAT){
	beat_bunbo = part_cur->val[1];
      }

      step = part_cur->org_xml_on_time.beat - pre_org_xml_on_time;
      step *= mul;

      part_cur->xml_on_time.beat = now_time + step;
      part_cur->xml_step.beat = step;
      part_cur->xml_on_diff.beat *= mul;
      part_cur->xml_len.beat *= mul;
      part_cur->xml_len_diff.beat *= mul;

      part_cur->on_time.beat = (part_cur->xml_on_time.beat / re_divi) * (beat_bunbo / 4.0);

      if( (part_cur->ident == NOTE) ||
	  (part_cur->ident == REST) ){
	now_time += step;
	pre_org_xml_on_time = part_cur->org_xml_on_time.beat;
      }

      if(part_cur->next == NULL){
	break;
      }
      part_cur = part_cur->next;
    }
  }


#if 0
  for(i = 0; i < part_num; i++){
    part_cur = part_top[i];
    while(1){
      if(part_cur->next == NULL){  break; }
      printf("%d: %5.3f, (%d)\n", i, part_cur->xml_on_time, part_cur->ident);
      part_cur = part_cur->next;
    }
  }
  exit(0);
#endif

  xmlSetTreeDoc(xml_top, xml_doc_top);

  br_printf(8, "Done.\n");

  return  EXIT_SUCCESS;
  /* ------  org_xml_on_time ŌvZR[hC܂ ------ */
}


/*
  XML ׂ̂Ă <duration> <relative-x> Ȃǂ redivisioning 
*/
static int allpart_redivi(xmlNode *top, int re_divi)
{
  xmlNode *cur;
  double mul;

  cur = top;
  while(cur != NULL){
    if (cur->type == XML_ELEMENT_NODE) {
      if(xmlStrcmp(cur->name, (const xmlChar *)"score-partwise") != 0){
	br_printf(2, "This is \"%s\" MusicXML.\n", cur->name);
	br_printf(2, "\"partwise\"  MusicXML ɂΉĂ܂D\n");
	exit(EXIT_FAILURE);
      }else{
	break;
      }
    }
    cur = cur->next;
  }
  /*  now: cur == "score-partwise"  */

  cur = cur->children;
  /*  now: cur == ("score-partwise" ̈)  */

  while(cur != NULL){
    if(cur->type == XML_ELEMENT_NODE){
      if(xmlStrcmp(cur->name, (const xmlChar *)"part") == 0){
	mul = 1.0;
	part_redivi(cur->children, re_divi, &mul);
      }
    }
    cur = cur->next;
  }

  return EXIT_SUCCESS;
}


static int part_redivi(xmlNode *top, int re_divi, double *mul)
{
  xmlNode *cur;
  int now_divi;
  xmlChar xmlchartmp[STR_LEN];
  int inttmp;
#define  NAME_NUM 1
  char chk_name[NAME_NUM][STR_LEN] ={
    "duration",
  };

#define  PROP_NUM  5
  char chk_prop[PROP_NUM][STR_LEN] ={
    /*
    "relative-x",
    "default-x",
    */
    "bezier-offset",
    "bezier-offset2",
    "bezier-x",
    "bezier-x2",
    "offset",
  };

  int i;
  double pre, aft;



  now_divi = re_divi;
  cur = top;
  while(cur != NULL){
    if (cur->type == XML_ELEMENT_NODE) {
      if(xmlStrcmp(cur->name, "divisions") == 0){
	sscanf(cur->children->content, "%d", &now_divi);
	(*mul) = (double)re_divi / (double)now_divi;
	sprintf(xmlchartmp, "%d", re_divi); /*  <divisions> ̒l  */
	xmlNodeSetContent(cur, xmlchartmp);
	sscanf(cur->children->content, "%d", &now_divi);
      }

      for(i = 0; i < NAME_NUM; i++){
	if(xmlStrcmp(cur->name, chk_name[i]) == 0){
	  sscanf(cur->children->content, "%d", &inttmp);
	  pre = (double)inttmp;
	  inttmp = inttmp * (*mul);
	  sprintf(xmlchartmp, "%d", inttmp); /*  <duration>l</duration> Ȃǂ̒l  */
	  xmlNodeSetContent(cur, xmlchartmp);
	  sscanf(cur->children->content, "%d", &inttmp);
	  aft = (double)inttmp;
	  if( (!(fabs((*mul) - 1.0) < 0.0625)) &&  /* mul == 1 ł͂Ȃ̂  */
	      (fabs(pre - aft) < 0.0625) ){  /*  pre == aft ύXłȂƂƂɂȂ  */
	    br_printf(2, "<%s> content can't change! *mul: %lf, pre: %lf, aft: %lf\n",
		      chk_name[i], *mul, pre, aft);
	  }
	}
      }
      for(i = 0; i < PROP_NUM; i++){
	if(xmlGetProp(cur, chk_prop[i]) != NULL){
	  sscanf(xmlGetProp(cur, chk_prop[i]), "%d", &inttmp);
	  pre = (double)inttmp;
	  inttmp = (double)inttmp * (*mul);
	  sprintf(xmlchartmp, "%d", inttmp); /*  <` relative-x="l"> Ȃǂ̒l  */
	  if(xmlSetProp(cur, chk_prop[i], xmlchartmp) == NULL){
	    br_printf(2, "prop re_division() fail!\n");
	    exit(EXIT_SUCCESS);
	  }
	  sscanf(xmlGetProp(cur, chk_prop[i]), "%d", &inttmp);
	  aft = (double)inttmp;
	  if( (!(fabs((*mul) - 1.0) < 0.0625)) &&  /* mul == 1 ł͂Ȃ̂  */
	      (fabs(pre - aft) < 0.0625) ){  /*  pre == aft ύXłȂƂƂɂȂ  */
	    br_printf(2, "%s prop can't change!\n", chk_name[i]);
	  }
	}
      }
    }
    part_redivi(cur->children, re_divi, mul);
    cur = cur->next;
  }
  
  return EXIT_SUCCESS;

}
