#include  <stdio.h>
#include  <stdlib.h>
#include  "SMFrw.h"
#include  "disp_ctr.h"


int smf_write(char *filename, SMF_HEADER *header_info, EL *top[MAX_TRK_NUM])
{
  FILE *fp;
  EL *cur;
  long trklen_pos;
  int trklen;
  int pre_delta;
  int now_delta;
  int i;
  int write_node;


  fp = fopen(filename, "wb");
  if(fp == NULL){
    br_printf(2, "t@C %s J܂łD\n", filename);
    exit(EXIT_FAILURE);
  }

  fprintf(fp, "MThd");
  fprintf(fp, "%c%c%c%c", 0x00, 0x00, 0x00, 0x06);  /*  length  */
  fprintf(fp, "%c%c", (header_info->format >> 8), header_info->format & 0xff);  /*  format  */
  fprintf(fp, "%c%c", (header_info->ntrks >> 8), header_info->ntrks & 0xff);  /*  ntrks(gbN)  */
  /*  division
      	(̕\(f^^C̎ԕ\)ɂ͑ΉĂȂ	*/
  fprintf(fp, "%c%c", (header_info->divi >> 8), header_info->divi & 0xff);
  
  write_node = 0;
  for(i = 0; i < header_info->ntrks; i++){
    if(top[i] == NULL){  continue;  }
    cur = top[i];
    trklen = 0;
    fprintf(fp, "MTrk");
    trklen_pos = ftell(fp);
    fprintf(fp, "%c%c%c%c", 0x00, 0x00, 0x00, 0x00);
    pre_delta = 0;
    now_delta = 0;
    while(cur != NULL){
/*       printf("%x %x %x\n", cur->stat, cur->val1, cur->val2); */
      now_delta = cur->abs_delta;
/*       printf("%d: %d: %d %X\n", i, now_delta, now_delta - pre_delta, cur->stat); */
      trklen += smf_put_delta(&fp, now_delta - pre_delta);
      trklen += smf_put_event(&fp, cur);
      write_node++;
      pre_delta = now_delta;
      cur = cur->next;
    }
    fseek(fp, trklen_pos, SEEK_SET);
    fprintf(fp, "%c%c%c%c",
	    (trklen >> 24) & 0xff,
	    (trklen >> 16) & 0xff,
	    (trklen >>  8) & 0xff,
	    (trklen >>  0) & 0xff);
    fseek(fp, 0, SEEK_END);
  }
  
  fclose(fp);

#ifdef DEBUG
  br_printf(-1, "Success!\n");
#endif
  br_printf(8, "%d node wrote.\n", write_node);


  return EXIT_SUCCESS;
}
